<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <div>
      <v-row justify="space-between" align="center">
        <v-col cols="1">
          <v-icon large>mdi-cogs</v-icon>
        </v-col>
        <v-col cols="7">
            <h2>
              {{execution.id}}
            </h2>
        </v-col>
        <v-col cols="4">
            <v-card-actions>
              <v-spacer/>
              <v-btn
                @click="loadExecution()"
                small
              >
                Refresh
                <v-icon small right dark>mdi-refresh</v-icon>
              </v-btn>
              <v-btn @click="$emit('cloneExecution', execution)" small>Run Again</v-btn>
            </v-card-actions>
        </v-col>
      </v-row>
    </div>

    <MessageBox
      :model="message"
      v-on:hide="message.show=false"
    />

    <CommonHeader
      title="General"
      description="General information about this execution"
    />

    <v-container>
      <v-row dense>
        <v-col cols="2" >
          <div class="esy-label">Status</div> <span :class="overall_status" style="border-radius:5px; padding:5px; font-weight:bold">{{overall_status}}</span>
        </v-col>
        <v-col cols="8" >
          <div class="esy-label">Start Time</div> {{starttime}}
        </v-col>
        <v-col cols="2" >
          <div class="esy-label">Duration</div> {{duration}}
        </v-col>
      </v-row>
      <v-row dense>
        <v-col cols="12" >
          <div class="esy-label">Execution ID</div> {{execution.id}}
        </v-col>
      </v-row>
      <v-row v-if="error">
        <v-col cols="12">
          <div class="esy-label">Error</div> <div v-html="error" class="console-err" style="overflow:unset; white-space:unset"></div>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
          <v-expansion-panels flat>
            <v-expansion-panel>
              <v-expansion-panel-header>
                <CommonHeader
                  subtitle="Full Log"
                  description="Full logs of the executor"
                />
              </v-expansion-panel-header>
              <v-expansion-panel-content>
                <div v-html="execution_log" class="console" style="overflow:auto; white-space:pre">></div>
              </v-expansion-panel-content>
            </v-expansion-panel>
          </v-expansion-panels>
        </v-col>
      </v-row>


    </v-container>

    <CommonHeader
      title="Provider"
      description="The provider on which the benchmark was executed."
    />

    <v-container>

      <v-list flat>
        <ProviderSummary
          v-if="execution.provider"
          :item="execution.provider"
          :key="execution.provider.id"
        />
        <div
          v-if="execution.provider==null"
        >
          <v-icon color="orange">mdi-alert</v-icon> You do not have sufficient permissions to access this provider
        </div>
      </v-list>

    </v-container>

    <template v-if="execution['one-time']">
      <CommonHeader
        title="Execution Request"
        description="This execution was triggered manually. Here is some info about the request."
      />
      <ExecutionRequestSummary
        v-if="request"
        :item="request"
        :key="request.id"
      />
      <v-container v-if="request==null">
        <v-icon color="orange">mdi-alert</v-icon> You do not have sufficient permissions to access the execution request parameters.
      </v-container>
    </template>

    <template v-else>
      <CommonHeader
        title="Schedule"
        description="This execution was triggered by a schedule. Here is some basic info about it as it was at execution time."
      />
      <ScheduleRequestSummary
        v-if="execution.schedule"
        :item="execution.schedule"
        :key="execution.schedule.id"
      />
      <v-container
        v-if="execution.schedule==null"
      >
        <v-icon color="orange">mdi-alert</v-icon> You do not have sufficient permissions to access this schedule
      </v-container>
    </template>

    <CommonHeader
      title="Scheduler Messages"
      description="Error messages reported by the submitter. Errors here usually means that no benchmark has been executed."
      v-if="any_error"
    />

    <v-row v-if="error">
      <v-col cols="12">
        <div class="esy-label">Error</div> <div v-html="error" class="console-err"></div>
      </v-col>
    </v-row>
    <v-row v-if="error_traceback">
      <v-col cols="12">
        <div class="esy-label">Error Traceback</div> <div v-html="error_traceback" class="console-err"></div>
      </v-col>
    </v-row>
    <v-row v-if="error_log">
      <v-col cols="12">
        <div class="esy-label">Error Log</div> <div v-html="error_log" class="console-err"></div>
      </v-col>
    </v-row>
    <v-row v-if="exception">
      <v-col cols="12">
        <div class="esy-label">Exception</div> <div v-html="exception" class="console-err"></div>
      </v-col>
    </v-row>
    <v-row v-if="execution.error_code">
      <v-col cols="12">
        <div class="esy-label">Error Code</div> <div v-html="execution.error_code" class="console-err"></div>
      </v-col>
    </v-row>
    <v-row v-if="docker_exception">
      <v-col cols="12">
        <div class="esy-label">Docker Exception</div> <div v-html="docker_exception" class="console-err"></div>
      </v-col>
    </v-row>


    <CommonHeader
      v-if="flatRuns.length>0"
      :title="'Tests (' + flatRuns.length + ')'"
      description="Metrics, logs and error messages for each test in this execution. You can find an entry for each combination of workload, image and size."
    />

    <v-expansion-panels
      v-model="panel"
      multiple
      flat
    >

    <RunViewer
      :run="run"
      :key="'run'+index"
      :seq="index"
      @selected="$emit('selected', run)"
      v-for="(run, index) in flatRuns"
    />

    </v-expansion-panels>

  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import MessageBox from '../common/MessageBox.vue';
import ProviderSummary from '../providers/ProviderSummary.vue';
import ScheduleRequestSummary from './ScheduleRequestSummary.vue';
import ExecutionRequestSummary from './ExecutionRequestSummary.vue';
import RunViewer from './RunViewer.vue';

import { buildResponse } from './executions.js';
import { formatDuration } from '../common/time.js';


export default {

 name: 'ExecutionViewer',

 components: {
    CommonHeader,
    ProviderSummary,
    ScheduleRequestSummary,
    RunViewer,
    MessageBox,
    ExecutionRequestSummary
  },

  props: {
    executionId: {
      type: String,
      default: ''
    }
  },

  data: () => ({
    execution : {grants:{}},

    runs: [],

    panel: [],

    flatRuns: [],

    timer: null,

    duration: "",

    request: {},

    message: {
      show: false,
      text: "",
      title: ""
    },
    enabledActions: {
      edit: false,
      clone: false,
      delete: false
    }
  }),

  created () {
    this.loadExecution()
  },

  mounted () {
    this.$vuetify.goTo(document.body, {duration:200})

    this.timer = setInterval(() => {
      this.updateTime()
    }, 1000)

  },

  beforeDestroy() {
    clearInterval(this.timer);
  },

  methods:{

    updateTime: function() {
      if(this.execution.starttime) {
        var st = this.execution.starttime.replace(" ", "T")+"Z";
        var et;
        if(this.execution.endtime) {
          et = this.execution.endtime.replace(" ", "T")+"Z";
          clearInterval(this.timer);
        }else {
          et = new Date();
        }
        var execTime = Date.parse(et)/1000 - Date.parse(st)/1000;

        this.duration=formatDuration(execTime);

        if(Math.floor(execTime)%10==0) {
          this.loadExecution();
        }
      }
      else {
        this.duration="n/a";
      }
    },

    resubmit: function() {
      this.$store.commit('fbkon')
      this.$http
            .get(this.$REST_BASE_URL + '/executions/'+this.executionId+'/request')
        .then(response => {
          var schedule = response.data;
          if(schedule)
            this.$emit('edit', schedule);
          else
            console.log("ERROR");
        })
      .finally(() => {this.$store.commit('fbkoff')});
    },

     loadExecution: function(){

      this.$store.commit('fbkon')
      this.$http
            .get(this.$REST_BASE_URL + '/executions/'+this.executionId)
        .then(response => {
          this.execution = response.data;
          this.$emit("title", "Execution " + this.execution.id);
        })
      .finally(() => {this.$store.commit('fbkoff')});

      this.$http
            .get(this.$REST_BASE_URL + '/executions/'+this.executionId+'/request')
        .then(response => {
          this.request = response.data;
        })
      .finally(() => {this.$store.commit('fbkoff')});

      this.$http
            .get(this.$REST_BASE_URL + '/executions/'+this.executionId+'/runs')
        .then(response => {
            this.runs = response.data;
            this.flatRuns.splice(0, this.flatRuns.length)

            // expand the run, if there's just one
            if(this.runs.length==1)
              this.panel=[0];

            var _hruns = {}
            for(var i in this.runs) {
              var run = this.runs[i];
              var wl = run.workload.name;
              var fl = run.image;
              var sz = run.provider.size;
              if(!_hruns[wl])
                _hruns[wl] = {};
              if(!_hruns[wl][fl])
                _hruns[wl][fl] = {};
              if(!_hruns[wl][fl][sz])
                _hruns[wl][fl][sz] = [];
              _hruns[wl][fl][sz].push(run);
            }
            // now flatten executions
            for(i in _hruns)
              for(var j in _hruns[i])
                for(var k in _hruns[i][j])
                  for(var l in _hruns[i][j][k])
                    this.flatRuns.push(_hruns[i][j][k][l])
         })
      .finally(() => {this.$store.commit('fbkoff')});
    },

  },


  computed: {
    overall_status: function() {
      var subko = 0;
      if(this.execution && this.execution.runs_status && this.execution.runs_status.error)
        subko = this.execution.runs_status.error.length;
      if(this.execution.status=="RUNNING" && subko>0)
        return "RUNNING";
      if(this.execution.status=="RUNNING" && subko==0)
        return "RUNNING";
      if(this.execution.status=="ERROR")
        return "ERROR";
      if(this.execution.status=="OK" && subko>0)
        return "ERROR";
      if(this.execution.status=="OK" && subko==0)
        return "OK";
      return this.execution.status;
    },
    execution_log: function() {
      return buildResponse(this.execution.log, "execution log")
    },
    any_error: function() {
      if(this.execution.error_log)
        return true;
      if(this.execution.docker_exception)
        return true;
      if(this.execution.error)
        return true;
      if(this.execution.error_traceback)
        return true;
      if(this.execution.exception)
        return true;
      if(this.execution.error_code)
        return true;
      return false;
    },
    error_log: function() {
      if(this.execution.error_log)
        return buildResponse(this.execution.error_log, "error log");
      else
        return null;
    },
    docker_exception: function() {
      if(this.execution.docker_exception)
        return buildResponse(this.execution.docker_exception, "error log");
      else
        return null;
    },
    error: function() {
      if(this.execution.error)
        return buildResponse(this.execution.error, "error log");
      else
        return null;
    },
    error_traceback: function() {
      if(this.execution.error_traceback)
        return buildResponse(this.execution.error_traceback, "error log");
      else
        return null;
    },
    exception: function() {
      if(this.execution.exception)
        return buildResponse(this.execution.exception, "error log");
      else
        return null;
    },
    starttime: function() {
      if(this.execution.starttime) {
        var st = this.execution.starttime.replace(" ", "T")+"Z";
        return new Date(Date.parse(st));
      }
      else {
        return null;
      }
    }
  }


};

</script>

<style>
  div.esy-label {
    color:rgba(0, 0, 0, 0.6);
    font-size:12px;
  }
  div.esy-label-normal, span.esy-label-normal {
    color:rgba(0, 0, 0, 0.6);
  }

</style>
